/***********************************************************************/
/*                                                                     */
/* RIGI C Parser --- Copyright (C) 1996-1999                           */
/*                    The Rigi Group, University of Victoria           */
/*                                                                     */
/* see the file license.terms for usage and copying policies           */
/*                                                                     */
/* Maintainer: Johannes Martin (jmartin@csr.csc.uvic.ca)               */
/*                                                                     */
/***********************************************************************/
#include "parmlist.h"

List<List<ParseInfo>*> ParameterList::parameters;

void ParameterList::start() {
  parameters.addTail(new List<ParseInfo>);
}

void ParameterList::close() {
  delete parameters.getTail();
  parameters.remTail();
}

void ParameterList::add(const ParseInfo& parameter) {
  parameters.getTail()->addTail(parameter);
}

bool ParameterList::more() {
  return !parameters.getTail()->empty();
}

ParseInfo ParameterList::get() {
  ParseInfo temp = parameters.getTail()->getFront();
  parameters.getTail()->remFront();
  return temp;
}

