/***********************************************************************/
/*                                                                     */
/* RIGI C Parser --- Copyright (C) 1996-1999                           */
/*                    The Rigi Group, University of Victoria           */
/*                                                                     */
/* see the file license.terms for usage and copying policies           */
/*                                                                     */
/* Maintainer: Johannes Martin (jmartin@csr.csc.uvic.ca)               */
/*                                                                     */
/***********************************************************************/
#ifndef __PARSE_H__
#define __PARSE_H__

// External declaration for functions that are called from the parser

#ifdef __cplusplus
extern "C"
#endif
void setprototype(bool b);
bool getprototype();

void settype(const char* s);
const char* gettype();

void setfunctype(const char* s);
const char* getfunctype();

void settypedeftype(const ParseInfo& info);
const ParseInfo& gettypedeftype();

void setstorage(int storage);
int getstorage();

const char *getfunc();
bool infunc();

void setstruct(const char* s);
const char* getstruct();
void popstruct();

void startfunc(const ParseInfo& p);
void endfunc(const ParseInfo& p);
void endproto(const ParseInfo& p);

void newvar(const ParseInfo& p);
void newconst(const ParseInfo& p);
void newtypedef(const ParseInfo& p);

void newcall(const ParseInfo& p);
void newdata(const ParseInfo& p);
void newref(const ParseInfo& p);

void newprototypes(const ParseInfo& protoInfo, const ParseInfo& implInfo);
void newdeclares(const ParseInfo& externInfo, const ParseInfo& newInfo);

void newtagged(const ParseInfo& p);

void newfile(const char* fileName);

#endif
